busybox=$(find /data/adb/ -type f -name busybox | head -n 1)
if [[ -z $busybox ]]; then
    echo "Busybox not found, aborting." >> /data/adb/zram_tweak.log
    exit 1
fi

if [[ ! -e /dev/block/zram0 ]]; then
    echo "ZRAM device not found, aborting." >> /data/adb/zram_tweak.log
    exit 1
fi

# Disable ZRAM before configuring
$busybox swapoff /dev/block/zram0
echo "1" > /sys/block/zram0/reset

# Set new ZRAM size
echo "4294967296" > /sys/block/zram0/disksize
$busybox mkswap /dev/block/zram0
$busybox swapon /dev/block/zram0

# Enable ZSWAP
if [[ -d /sys/module/zswap ]]; then
    echo 1 > /sys/module/zswap/parameters/enabled
    echo zstd > /sys/module/zswap/parameters/compressor
    echo 20 > /sys/module/zswap/parameters/max_pool_percent
fi

# Set VM and activity manager tweaks
echo 100 > /proc/sys/vm/swappiness
settings put global activity_manager_constants max_cached_processes=8
settings put global app_standby_enabled=true

echo "ZRAM and ZSWAP configured successfully" >> /data/adb/zram_tweak.log